#! /bin/sh
# postinst script for lazarus
#
# see: dh_installdeb(1)

set -e

# summary of how this script can be called:
#        * <postinst> `configure' <most-recently-configured-version>
#        * <old-postinst> `abort-upgrade' <new version>
#        * <conflictor's-postinst> `abort-remove' `in-favour' <package>
#          <new-version>
#        * <deconfigured's-postinst> `abort-deconfigure' `in-favour'
#          <failed-install-package> <version> `removing'
#          <conflicting-package> <version>
# for details, see http://www.debian.org/doc/debian-policy/ or
# the debian-policy package
#

case "$1" in
    configure)
	wget -c -P /usr/src http://ftp.debian.org/debian/pool/main/f/fpc/fpc_1.0.10-1.2.dsc
	wget -c -P /usr/src http://ftp.debian.org/debian/pool/main/f/fpc/fpc_1.0.10.orig.tar.gz
	wget -c -P /usr/src http://ftp.debian.org/debian/pool/main/f/fpc/fpc_1.0.10-1.2.diff.gz
        dpkg -x /usr/src/fpc_1.0.10-1.2.dsc
    ;;

    abort-upgrade|abort-remove|abort-deconfigure)

    ;;

    *)
        echo "postinst called with unknown argument \`$1'" >&2
        exit 1
    ;;
esac

# dh_installdeb will replace this with shell code automatically
# generated by other debhelper scripts.

#DEBHELPER#

exit 0


