{%MainUnit ../dialogs.pp}
{
 *****************************************************************************
 *                                                                           *
 *  This file is part of the Lazarus Component Library (LCL)                 *
 *                                                                           *
 *  See the file COPYING.modifiedLGPL, included in this distribution,        *
 *  for details about the copyright.                                         *
 *                                                                           *
 *  This program is distributed in the hope that it will be useful,          *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                     *
 *                                                                           *
 *****************************************************************************
}
type
   PCharArray32x32 = Array [0..38]  of PChar;

const
  IMGWarning : PCharArray32x32 =
   (
  '32 32 6 1',
  '. c None',
  'c c #000000',
  '# c #808000',
  'd c #808080',
  'b c #c0c0c0',
  'a c #ffff00',
  '.............###................',
  '............#aabc...............',
  '...........#aaaabcd.............',
  '...........#aaaaacdd............',
  '..........#aaaaaabcdd...........',
  '..........#aaaaaaacdd...........',
  '.........#aaaaaaaabcdd..........',
  '.........#aaaaaaaaacdd..........',
  '........#aaaaaaaaaabcdd.........',
  '........#aaabcccbaaacdd.........',
  '.......#aaaacccccaaabcdd........',
  '.......#aaaacccccaaaacdd........',
  '......#aaaaacccccaaaabcdd.......',
  '......#aaaaacccccaaaaacdd.......',
  '.....#aaaaaacccccaaaaabcdd......',
  '.....#aaaaaa#ccc#aaaaaacdd......',
  '....#aaaaaaabcccbaaaaaabcdd.....',
  '....#aaaaaaaacccaaaaaaaacdd.....',
  '...#aaaaaaaaa#c#aaaaaaaabcdd....',
  '...#aaaaaaaaabcbaaaaaaaaacdd....',
  '..#aaaaaaaaaaacaaaaaaaaaabcdd...',
  '..#aaaaaaaaaaaaaaaaaaaaaaacdd...',
  '.#aaaaaaaaaaabccbaaaaaaaaabcdd..',
  '.#aaaaaaaaaaaccccaaaaaaaaaacdd..',
  '#aaaaaaaaaaaaccccaaaaaaaaaabcdd.',
  '#aaaaaaaaaaaabccbaaaaaaaaaaacdd.',
  '#aaaaaaaaaaaaaaaaaaaaaaaaaaacddd',
  '#aaaaaaaaaaaaaaaaaaaaaaaaaabcddd',
  '.#aaaaaaaaaaaaaaaaaaaaaaaabcdddd',
  '..#ccccccccccccccccccccccccddddd',
  '....ddddddddddddddddddddddddddd.',
  '.....ddddddddddddddddddddddddd..');

  IMGInfo : PCharArray32x32 =
    (
    '32 32 6 1',
    '. c None',
    'd c #000000',
    'c c #0000ff',
    '# c #808080',
    'a c #c0c0c0',
    'b c #ffffff',
    '...........########.............',
    '........###abbbbbba###..........',
    '......##abbbbbbbbbbbba##........',
    '.....#abbbbbbbbbbbbbbbba#.......',
    '....#bbbbbbbaccccabbbbbbbd......',
    '...#bbbbbbbbccccccbbbbbbbbd.....',
    '..#bbbbbbbbbccccccbbbbbbbbbd....',
    '.#abbbbbbbbbaccccabbbbbbbbbad...',
    '.#bbbbbbbbbbbbbbbbbbbbbbbbbbd#..',
    '#abbbbbbbbbbbbbbbbbbbbbbbbbbad#.',
    '#bbbbbbbbbbcccccccbbbbbbbbbbbd#.',
    '#bbbbbbbbbbbbcccccbbbbbbbbbbbd##',
    '#bbbbbbbbbbbbcccccbbbbbbbbbbbd##',
    '#bbbbbbbbbbbbcccccbbbbbbbbbbbd##',
    '#bbbbbbbbbbbbcccccbbbbbbbbbbbd##',
    '#abbbbbbbbbbbcccccbbbbbbbbbbad##',
    '.#bbbbbbbbbbbcccccbbbbbbbbbbd###',
    '.#abbbbbbbbbbcccccbbbbbbbbbad###',
    '..#bbbbbbbbcccccccccbbbbbbbd###.',
    '...dbbbbbbbbbbbbbbbbbbbbbbd####.',
    '....dbbbbbbbbbbbbbbbbbbbbd####..',
    '.....dabbbbbbbbbbbbbbbbad####...',
    '......ddabbbbbbbbbbbbadd####....',
    '.......#dddabbbbbbaddd#####.....',
    '........###dddabbbd#######......',
    '..........####dbbbd#####........',
    '.............#dbbbd##...........',
    '...............dbbd##...........',
    '................dbd##...........',
    '.................dd##...........',
    '..................###...........',
    '...................##...........');

  IMGError : PCharArray32x32 =
    (
	'32 32 5 1',
	'. c None',
	'# c #800000',
	'b c #808080',
	'a c #ff0000',
	'c c #ffffff',
	'...........########.............',
	'........###aaaaaaaa###..........',
	'.......#aaaaaaaaaaaaaa#.........',
	'.....##aaaaaaaaaaaaaaaa##.......',
	'....#aaaaaaaaaaaaaaaaaaaa#......',
	'...#aaaaaaaaaaaaaaaaaaaaaa#.....',
	'...#aaaaaaaaaaaaaaaaaaaaaa#b....',
	'..#aaaaaacaaaaaaaaaacaaaaaa#b...',
	'.#aaaaaacccaaaaaaaacccaaaaaa#...',
	'.#aaaaacccccaaaaaacccccaaaaa#b..',
	'.#aaaaaacccccaaaacccccaaaaaa#bb.',
	'#aaaaaaaacccccaacccccaaaaaaaa#b.',
	'#aaaaaaaaaccccccccccaaaaaaaaa#b.',
	'#aaaaaaaaaaccccccccaaaaaaaaaa#bb',
	'#aaaaaaaaaaaccccccaaaaaaaaaaa#bb',
	'#aaaaaaaaaaaccccccaaaaaaaaaaa#bb',
	'#aaaaaaaaaaccccccccaaaaaaaaaa#bb',
	'#aaaaaaaaaccccccccccaaaaaaaaa#bb',
	'#aaaaaaaacccccaacccccaaaaaaaa#bb',
	'.#aaaaaacccccaaaacccccaaaaaa#bbb',
	'.#aaaaacccccaaaaaacccccaaaaa#bbb',
	'.#aaaaaacccaaaaaaaacccaaaaaa#bb.',
	'..#aaaaaacaaaaaaaaaacaaaaaa#bbb.',
	'...#aaaaaaaaaaaaaaaaaaaaaa#bbbb.',
	'...#aaaaaaaaaaaaaaaaaaaaaa#bbb..',
	'....#aaaaaaaaaaaaaaaaaaaa#bbb...',
	'.....##aaaaaaaaaaaaaaaa##bbbb...',
	'......b#aaaaaaaaaaaaaa#bbbbb....',
	'.......b###aaaaaaaa###bbbbb.....',
	'.........bb########bbbbbb.......',
	'..........bbbbbbbbbbbbbb........',
	'.............bbbbbbbb...........',
	'................................');

  IMGConfirmation : PCharArray32x32 =
    (
	'32 32 6 1',
	'. c None',
	'c c #000000',
	'd c #0000ff',
	'# c #808080',
	'a c #c0c0c0',
	'b c #ffffff',
	'................................',
	'...........########.............',
	'........###abbbbbba###..........',
	'......##abbbbbbbbbbbba##........',
	'.....#abbbbbbbbbbbbbbbba#.......',
	'....#bbbbbbbbbbbbbbbbbbbbc......',
	'...#bbbbbbbaddddddabbbbbbbc.....',
	'..#bbbbbbbadabbddddabbbbbbbc....',
	'.#abbbbbbbddbbbbddddbbbbbbbac...',
	'.#bbbbbbbbddddbbddddbbbbbbbbc#..',
	'#abbbbbbbbddddbaddddbbbbbbbbac#.',
	'#bbbbbbbbbaddabddddbbbbbbbbbbc#.',
	'#bbbbbbbbbbbbbadddbbbbbbbbbbbc##',
	'#bbbbbbbbbbbbbdddbbbbbbbbbbbbc##',
	'#bbbbbbbbbbbbbddabbbbbbbbbbbbc##',
	'#bbbbbbbbbbbbbddbbbbbbbbbbbbbc##',
	'#abbbbbbbbbbbbbbbbbbbbbbbbbbac##',
	'.#bbbbbbbbbbbaddabbbbbbbbbbbc###',
	'.#abbbbbbbbbbddddbbbbbbbbbbac###',
	'..#bbbbbbbbbbddddbbbbbbbbbbc###.',
	'...cbbbbbbbbbaddabbbbbbbbbc####.',
	'....cbbbbbbbbbbbbbbbbbbbbc####..',
	'.....cabbbbbbbbbbbbbbbbac####...',
	'......ccabbbbbbbbbbbbacc####....',
	'.......#cccabbbbbbaccc#####.....',
	'........###cccabbbc#######......',
	'..........####cbbbc#####........',
	'.............#cbbbc##...........',
	'...............cbbc##...........',
	'................cbc##...........',
	'.................cc##...........',
	'..................###...........');
